function ToggleVote()
	if(ElgohVote:IsShown()) then 
		ElgohVote:Hide();
		frmMain:SetHeight(frmMain:GetHeight()-ElgohVote:GetHeight())
	else
		if(edtItem:GetText()=="") then edtItem:SetText("Item"); end
		ElgohVote:Show();
		frmMain:SetHeight(frmMain:GetHeight()+ElgohVote:GetHeight())
	end
end

function OVoteT()
	if(OElgohVote:IsShown()) then 
		OElgohVote:Hide();
		frmOfficer:SetHeight(frmOfficer:GetHeight()-OElgohVote:GetHeight())
	else
		OElgohVote:Show();
		OElgohVote:SetWidth(frmOfficer:GetWidth());
		frmOfficer:SetHeight(frmOfficer:GetHeight()+OElgohVote:GetHeight())
		if(PollTitle==nil) then
			Poll_New();
		end
	end
end

function Vote_Refresh()
	for n=1,#PollItems do
		if(VoteButtons[n]==nil) then
			VoteButtons[n]=CreateFrame("Button",nil,caMain,"UIPanelButtonTemplate")
			VoteButtons[n]:RegisterForClicks("AnyUp");
			VoteButtons[n]:SetScript("OnClick", toggle);
			if(n<6) then
				VoteButtons[n]:SetPoint("TOPLEFT", "caMain", "TOPLEFT", 15, -((n*25)));
			else
				VoteButtons[n]:SetPoint("TOPLEFT", "caMain", "TOPLEFT", 180, -(((n-5)*25)));
			end
			VoteButtons[n]:SetWidth(150)
			VoteButtons[n]:SetHeight(25)
		end
		if(GetRaidRosterInfo(n)) then
			VoteButtons[n]:SetText("|cffffffff"..raidername.." hasn't given|r");
			height=height+25;
		else
			VoteButtons[n]:Hide();
		end
	end
end

function Poll_New()
	PollItems = {};
	PollVotes = {};
	PollVoting = false;
	PollTexts={};
	PollTitle="Officer Vote:";
	edtPollTitle:SetText("Officer Vote:");
end

function Poll_SetItem(itemName, index)
	if (index ~= nil) then
		index = math.floor(index)
		PollItems[index] = itemName
	end

	Poll_OrderItems();
	Poll_List();
	return true
end

function Elgoh_RemoveItem(self, button)
	for index=1,#PollItems do
		if (PollItems[index] == self:GetText()) then
			frmOfficer:SetHeight(frmOfficer:GetHeight()-30);
			OElgohVote:SetHeight(OElgohVote:GetHeight()-30);
			table.remove(PollItems, index);
			self:Hide();
			Poll_OrderItems();
			return true;
		end
	end
end

function Elgoh_AddItem(item)
	if(#PollItems==5) then 
		print("Elgoh: Only 5 items may be added");
		return false; 
	end
	if(not item) then return false; end
	if(item=="") then return false; end
	for index=0,#PollItems do
		if (PollItems[index] == item) then
			print("Elgoh: Item already exist at "..index);
			PlaySoundFile("Sound\\interface\\Error.wav");
			return false;
		end
	end
	
	frmOfficer:SetHeight(frmOfficer:GetHeight()+30);
	OElgohVote:SetHeight(OElgohVote:GetHeight()+30);
	edtItem:SetText("");
	table.insert(PollItems, index)
		PollItems[#PollItems+1]=item;
	Poll_OrderItems()
	return true
end

function Elgoh_List(listing)
	local index, itemName
	if(listing==1) then
		PostTo("Elgoh: Current items in the vote:");
	end
	for index, itemName in pairs(PollItems) do
		PostTo(index..": "..itemName)
	end
end

function Poll_Vote(player, index)
	local index
	local indexValid, alreadyVoted

	if (not PollVoting) then
		return false
	end

	indexValid = (index ~= nil) and (PollItems[index] ~= nil)

	alreadyVoted = (PollVotes[player] ~= nil)

	if (not indexValid or alreadyVoted) then
		return false
	end

	PollVotes[player] = {}
	PollVotes[player]["item"] = index

	local numVotes = 0
	for _, _ in pairs(PollVotes) do
		numVotes = numVotes + 1
	end

	if (numVotes == GetNumRaidMembers()) then
		Poll_StopVote()
	end

	return true
end

function Elgoh_Start()
	if (PollVoting == true) then
		print("Elgoh: Another vote is already in progress");
		return false
	end
	
	if (#PollItems < 2) then
		print("Elgoh: You need to add at least 2 items");
		return false
	end
	PollVoteDuration = 15;
	PollVotes = {};
	ElgohVote.TimeSinceLastUpdate = 0;
	PollVoting = true;
	PostTo(edtPollTitle:GetText());
	Elgoh_List(0);
	SendAddonMessage("elgohv", "new", "RAID");
end

function Elgoh_Stop()
	PollVoting = false
	Poll_GetResults();
	Poll_New();
	Poll_OrderItems();
end

function Poll_GetResults()
	for _, item in pairs(PollVotes) do
		Results[item]["tally"]=Results[item]["tally"]+1
	end
	for item,_ in pairs(Results) do
		print(Results[item]["tally"]);
	end
end

function Poll_OrderItems()
	local index, itemName
	local indexes, newItemList
	newItemList = {}
	indexes = {}
	
	for index, _ in pairs(PollItems) do
		table.insert(indexes, index)
	end
	
	table.sort(indexes)
	
	for _, index in pairs(indexes) do
		newItemList[index] = PollItems[index]
	end

	PollItems = newItemList
	
	for index, itemName in pairs(PollItems) do
		if(PollTexts[index]==nil) then
			PollTexts[index]=CreateFrame("Button",nil,OElgohVote,"UIPanelButtonTemplate")
			PollTexts[index]:RegisterForClicks("AnyUp");
			PollTexts[index]:SetScript("OnClick", Elgoh_RemoveItem);
			PollTexts[index]:SetPoint("TOP", "OElgohVote", "TOP", 0, -(55+(index*25)));
			PollTexts[index]:SetWidth(150)
			PollTexts[index]:SetHeight(20)
			PollTexts[index]:Hide();
		else
			PollTexts[index]:Hide();
		end
		if(PollItems[index]) then
			PollTexts[index]:SetText(PollItems[index]);
			PollTexts[index]:Show();
		else
			PollTexts[index]:Hide();
		end
	end
end

function Poll_OnLoad()
	OElgohVote:RegisterEvent("CHAT_ADDON_MESSAGE");
	OElgohVote.TimeSinceLastUpdate = 0;
	PollVoting = false;
	OElgohVote:SetScript("OnEvent",  Poll_OnEvent);
	OElgohVote:SetScript("OnUpdate", OElgohVote_OnUpdate);
end


function Poll_OnEvent(event, ...)
if (event == "CHAT_ADDON_MESSAGE") then
	local prefix, msg, how, who = select(1, ...);
	if(msg=="new") then
		PollVoting=true;
	else
		PollVote(who, msg);
	end
end
end


function OElgohVote_OnUpdate(this, arg1)
	if ((not PollVoting) or (PollVoteDuration == 0)) then return end
	
	OElgohVote.TimeSinceLastUpdate = OElgohVote.TimeSinceLastUpdate + arg1
	if( OElgohVote.TimeSinceLastUpdate > PollVoteDuration ) then
		Poll_StopVote()
	end
	if(OElgohVote.TimeSinceLastUpdate==PollVoteDuration-1) then
		PostTo("1");
	end
	if(OElgohVote.TimeSinceLastUpdate==PollVoteDuration-2) then
		PostTo("2");
	end
	if(OElgohVote.TimeSinceLastUpdate==PollVoteDuration-3) then
		PostTo("3");
	end
end